diff --git a/pki/base/common/src/com/netscape/cms/servlet/key/DisplayBySerialForRecovery.java b/pki/base/common/src/com/netscape/cms/servlet/key/DisplayBySerialForRecovery.java
index 1ef0ba40b7bfe8db3f7a40a5b91201524f3b7b16..72294cd4c765d29ac54c536b25aa11deb61bc101 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/key/DisplayBySerialForRecovery.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/key/DisplayBySerialForRecovery.java
@@ -116,7 +116,7 @@ public class DisplayBySerialForRecovery extends CMSServlet {
 
         try {
             authzToken = authorize(mAclMethod, authToken,
-                        mAuthzResourceName, "read");
+                    mAuthzResourceName, "read");
         } catch (EAuthzAccessDenied e) {
             log(ILogger.LL_FAILURE,
                     CMS.getLogMessage("ADMIN_SRVLT_AUTH_FAILURE", e.toString()));
@@ -150,12 +150,11 @@ public class DisplayBySerialForRecovery extends CMSServlet {
         IArgBlock fixed = CMS.createArgBlock();
         CMSTemplateParams argSet = new CMSTemplateParams(header, fixed);
 
-        int seqNum = -1;
+        BigInteger seqNum = BigInteger.ZERO;
 
         try {
             if (req.getParameter(IN_SERIALNO) != null) {
-                seqNum = Integer.parseInt(
-                            req.getParameter(IN_SERIALNO));
+                seqNum = new BigInteger(req.getParameter(IN_SERIALNO));
             }
             process(argSet, header,
                     req.getParameter("publicKeyData"),
@@ -185,7 +184,7 @@ public class DisplayBySerialForRecovery extends CMSServlet {
      * Display information about a particular key.
      */
     private synchronized void process(CMSTemplateParams argSet,
-            IArgBlock header, String publicKeyData, int seq,
+            IArgBlock header, String publicKeyData, BigInteger seq,
             HttpServletRequest req, HttpServletResponse resp,
             Locale locale) {
         try {
@@ -201,8 +200,7 @@ public class DisplayBySerialForRecovery extends CMSServlet {
                 header.addStringValue("publicKeyData",
                         publicKeyData);
             }
-            IKeyRecord rec = (IKeyRecord) mKeyDB.readKeyRecord(new
-                    BigInteger(Integer.toString(seq)));
+            IKeyRecord rec = (IKeyRecord) mKeyDB.readKeyRecord(seq);
 
             KeyRecordParser.fillRecordIntoArg(rec, header);
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/key/KeyRecordParser.java b/pki/base/common/src/com/netscape/cms/servlet/key/KeyRecordParser.java
index 1171236b8e3dc5cd71e52593717d341f4e32a013..d6bc57fcf0233232e4d7e4e2ec1c4b94fc5c53a7 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/key/KeyRecordParser.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/key/KeyRecordParser.java
@@ -17,6 +17,7 @@
 // --- END COPYRIGHT BLOCK ---
 package com.netscape.cms.servlet.key;
 
+import java.math.BigInteger;
 import java.util.Date;
 
 import com.netscape.certsrv.apps.CMS;
@@ -54,8 +55,8 @@ public class KeyRecordParser {
                 rec.getState().toString());
         rarg.addStringValue(OUT_OWNER_NAME,
                 rec.getOwnerName());
-        rarg.addIntegerValue(OUT_SERIALNO,
-                rec.getSerialNumber().intValue());
+        rarg.addBigIntegerValue(OUT_SERIALNO,
+                rec.getSerialNumber(), 10);
         rarg.addStringValue(OUT_KEY_ALGORITHM,
                 rec.getAlgorithm());
         // Possible Enhancement: sun's BASE64Encode is not 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/key/RecoverBySerial.java b/pki/base/common/src/com/netscape/cms/servlet/key/RecoverBySerial.java
index 8abafa155dd17a27be61690d473d93ee7bd08ec8..ce4bc990083a9105266027e8007ea211de1252c2 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/key/RecoverBySerial.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/key/RecoverBySerial.java
@@ -134,7 +134,7 @@ public class RecoverBySerial extends CMSServlet {
 
         try {
             authzToken = authorize(mAclMethod, authToken,
-                        mAuthzResourceName, "recover");
+                    mAuthzResourceName, "recover");
         } catch (EAuthzAccessDenied e) {
             log(ILogger.LL_FAILURE,
                     CMS.getLogMessage("ADMIN_SRVLT_AUTH_FAILURE", e.toString()));
@@ -271,7 +271,7 @@ public class RecoverBySerial extends CMSServlet {
         }
         X509CertImpl x509cert = null;
 
-        if (cert == null) {
+        if (cert == null || cert.trim().length() == 0) {
             header.addStringValue(OUT_ERROR, "certificate not found");
             return;
         } else {
@@ -291,7 +291,7 @@ public class RecoverBySerial extends CMSServlet {
         try {
             String reqID = mService.initAsyncKeyRecovery(
                     new BigInteger(seq), x509cert,
-                      (String) sContext.get(SessionContext.USER_ID));
+                    (String) sContext.get(SessionContext.USER_ID));
             header.addStringValue(OUT_SERIALNO, req.getParameter(IN_SERIALNO));
             header.addStringValue("requestID", reqID);
         } catch (EBaseException e) {
@@ -335,7 +335,7 @@ public class RecoverBySerial extends CMSServlet {
         }
         X509CertImpl x509cert = null;
 
-        if (cert == null) {
+        if (cert == null || cert.trim().length() == 0) {
             // perform recovery
             header.addStringValue(OUT_ERROR, "certificate not found");
             return null;
@@ -407,8 +407,8 @@ public class RecoverBySerial extends CMSServlet {
 
                 header.addStringValue(OUT_OP,
                         req.getParameter(OUT_OP));
-                header.addIntegerValue(OUT_SERIALNO,
-                        Integer.parseInt(seq));
+                header.addBigIntegerValue(OUT_SERIALNO,
+                        new BigInteger(seq), 10);
                 header.addStringValue(OUT_SERVICE_URL,
                         req.getRequestURI());
                 byte pkcs12[] = mService.doKeyRecovery(
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/CheckRequest.java b/pki/base/common/src/com/netscape/cms/servlet/request/CheckRequest.java
index b53413dcf1cd4c22e4328c3a46c410ef1a04f57c..db3e9088d586475e5f23e3b1787bc4cd8e1cc0d4 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/CheckRequest.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/CheckRequest.java
@@ -27,6 +27,7 @@ import java.security.NoSuchAlgorithmException;
 import java.security.cert.X509Certificate;
 import java.util.Locale;
 import java.util.StringTokenizer;
+import java.math.BigInteger;
 
 import javax.servlet.ServletConfig;
 import javax.servlet.ServletException;
@@ -160,7 +161,7 @@ public class CheckRequest extends CMSServlet {
 
         try {
             authzToken = authorize(mAclMethod, authToken,
-                        mAuthzResourceName, "read");
+                    mAuthzResourceName, "read");
         } catch (EAuthzAccessDenied e) {
             log(ILogger.LL_FAILURE,
                     CMS.getLogMessage("ADMIN_SRVLT_AUTH_FAILURE", e.toString()));
@@ -279,7 +280,7 @@ public class CheckRequest extends CMSServlet {
             throw new ECMSGWException(CMS.getUserMessage("CMS_GW_NO_REQUEST_ID_PROVIDED"));
         }
         try {
-            Integer.parseInt(requestId);
+            new BigInteger(requestId);
         } catch (NumberFormatException e) {
             log(ILogger.LL_FAILURE, CMS.getLogMessage("BASE_INVALID_NUMBER_FORMAT_1", requestId));
             throw new EBaseException(
@@ -446,17 +447,17 @@ public class CheckRequest extends CMSServlet {
                                         // create recipientNonce
                                         if (transIds != null) {
                                             ta = new TaggedAttribute(new
-                                                        INTEGER(bpid++),
-                                                        OBJECT_IDENTIFIER.id_cmc_transactionId,
-                                                        transIds);
+                                                    INTEGER(bpid++),
+                                                    OBJECT_IDENTIFIER.id_cmc_transactionId,
+                                                    transIds);
                                             controlSeq.addElement(ta);
                                         }
 
                                         if (sNonces != null) {
                                             ta = new TaggedAttribute(new
-                                                        INTEGER(bpid++),
-                                                        OBJECT_IDENTIFIER.id_cmc_recipientNonce,
-                                                        sNonces);
+                                                    INTEGER(bpid++),
+                                                    OBJECT_IDENTIFIER.id_cmc_recipientNonce,
+                                                    sNonces);
                                             controlSeq.addElement(ta);
                                         }
 
@@ -474,9 +475,9 @@ public class CheckRequest extends CMSServlet {
                                         String[] newNonce = { b64E };
 
                                         ta = new TaggedAttribute(new
-                                                    INTEGER(bpid++),
-                                                    OBJECT_IDENTIFIER.id_cmc_senderNonce,
-                                                    new OCTET_STRING(newNonce[0].getBytes()));
+                                                INTEGER(bpid++),
+                                                OBJECT_IDENTIFIER.id_cmc_senderNonce,
+                                                new OCTET_STRING(newNonce[0].getBytes()));
                                         controlSeq.addElement(ta);
 
                                         ResponseBody rb = new ResponseBody(controlSeq, new
